unit Manager;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ShellAPI, StdCtrls, ExtCtrls, Menus, FileCtrl, ImgList;

type
  TForm1 = class(TForm)
    TreeView: TTreeView;
    ListView: TListView;
    Panel1: TPanel;
    Label1: TLabel;
    Edit: TEdit;
    MainMenu1: TMainMenu;
    Soubor: TMenuItem;
    Nov1: TMenuItem;
    Soubor1: TMenuItem;
    Sloka1: TMenuItem;
    Sma1: TMenuItem;
    Edit1: TMenuItem;
    Select1: TMenuItem;
    Kopruj1: TMenuItem;
    Pesu1: TMenuItem;
    N2: TMenuItem;
    Opus1: TMenuItem;
    Zobrazovatsoubory1: TMenuItem;
    Skryt1: TMenuItem;
    Systmov1: TMenuItem;
    Jenproten1: TMenuItem;
    Archivan1: TMenuItem;
    Maska1: TMenuItem;
    PopupMenu: TPopupMenu;
    Kopruj2: TMenuItem;
    Pesu2: TMenuItem;
    Sma2: TMenuItem;
    Spotejvelikost1: TMenuItem;
    Spotejvelikost2: TMenuItem;
    Disk1: TMenuItem;
    Najdi2: TMenuItem;
    Volnmsto1: TMenuItem;
    Kapacitadisku1: TMenuItem;
    Volnmsto2: TMenuItem;
    Kapacitadisku2: TMenuItem;
    StatusBar: TStatusBar;
    Vybervechny1: TMenuItem;
    Prohldni1: TMenuItem;
    Prohldni2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure LoadDrives;
    procedure AddDrives;
    procedure UpdateFileList;
    procedure CreateFileColumns;
    procedure CreateDriveColumns;
    procedure LevelUp;
    procedure ReLoad;
    procedure LoadRoot;
    procedure DeleteItems(all: integer);
    procedure DeleteNode(all: integer);
    procedure SetDirectory(NewDir: string);
    procedure OpenPath(dPath: string);
    procedure AddSubs(Path: string;Node: TTreeNode);
    procedure MakePath(Node:TTreeNode);
    function AddSlash(Path: string): string;
    function GetPathFromNode(Node: TTreeNode): string;
    function ConvertSize(FSize: integer; FAttr: String): String;
    procedure TreeViewExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    function AddFiles(FileMask: string; Attr: DWord): Boolean;
    procedure TreeViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListViewDblClick(Sender: TObject);
    function ExecuteFile(const Operation, FileName, Params, DefaultDir: string;
      ShowCmd: Integer): THandle;
    procedure TreeViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure Soubor1Click(Sender: TObject);
    procedure Sloka1Click(Sender: TObject);
    function FileDirExist(FDName: string): Boolean;
    function DelSlash(Path: string): string;
    procedure Sma1Click(Sender: TObject);
    procedure Najdi1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Kopruj1Click(Sender: TObject);
    procedure Pesu1Click(Sender: TObject);
    procedure Opus1Click(Sender: TObject);
    procedure Copyfiles(Path: string; all: integer);
    procedure Skryt1Click(Sender: TObject);
    procedure Systmov1Click(Sender: TObject);
    procedure Jenproten1Click(Sender: TObject);
    procedure Archivan1Click(Sender: TObject);
    procedure Maska1Click(Sender: TObject);
    procedure ListViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Spotejvelikost1Click(Sender: TObject);
    procedure Volnmsto1Click(Sender: TObject);
    procedure Kapacitadisku1Click(Sender: TObject);
    procedure ListViewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Vybervechny1Click(Sender: TObject);
    procedure TreeViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure ListViewEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure Prohldni1Click(Sender: TObject);
    function GetSelectedIcon(Path: string): Integer;
    function GetNormalIcon(Path: string): integer;
    procedure WMDeviceChange(var Msg: TMessage); message WM_DEVICECHANGE;
    procedure CompareFiles(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure ColumnClick(Sender: TObject; Column: TListColumn);

  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FSelectedPath: string;
  TreeViewPath: string;
  FDirectory: string;
  FMask: string;
  FSortColumn: integer;
  FSortForward: boolean;

implementation

uses Show;

{$R *.DFM}

procedure TForm1.ColumnClick(Sender: TObject; Column: TListColumn);
var
  required_column: integer;
begin
  required_column := Column.Index;
  if required_column = FSortColumn then
    FSortForward := not FSortForward
  else
  begin
    FSortColumn := required_column;
    FSortForward := True;
  end;
  ListView.SortType := stData;
  ListView.SortType := stNone;
end;

procedure TForm1.CompareFiles(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var
  Caption1, Caption2: string;
  size1, size2: integer;
  result: integer;
begin
  Result := 0;
  if (Item1.SubItems[0] = 'dir') and (Item2.SubItems[0] <> 'dir') then
    Result := -1
  else if (Item1.SubItems[0] <> 'dir') and (Item2.SubItems[0] = 'dir')
    then
    Result := 1
  else
  begin
    if FSortColumn = 0 then
    begin
      Caption1 := AnsiUpperCase(Item1.Caption);
      Caption2 := AnsiUpperCase(Item2.Caption);
      if Caption1 > Caption2 then
        Result := 1
      else if Caption1 < Caption2 then
        Result := -1;
    end
    else if FSortColumn = 2 then
    begin
      if (ListView.Items.Item[1].SubItems[1] = 'drv') then exit;
      size1 := StrToInt(Trim(Item1.SubItems.Strings[1]));
      size2 := StrToInt(Trim(Item2.SubItems.Strings[1]));
      if Size1 > Size2 then
        Result := 1
      else if Size1 < Size2 then
        Result := -1;
    end
  end;
  if FSortForward then
    Compare := -result
  else
    Compare := result;
end;

procedure TForm1.WMDeviceChange (var Msg: TMessage);
const
  CD_IN  = $8000;
  CD_OUT = $8004;
begin
  inherited;
  if (Msg.wParam = CD_IN) or(Msg.wParam = CD_OUT) then
  begin
    ReLoad;
    UpdateFileList;
  end;
end;

function TForm1.AddSlash(Path: string): string;
begin
  if Path = '' then exit;
  if Path[Length(Path)] <> '\' then
    Result := Path + '\'
  else
    Result := Path;
end;

procedure TForm1.LoadDrives;
var
  Drives: set of 0..25;
  ADrive: integer;
  DriveLetter: char;
  DriveString,DrvName: string;
  Sfi: TSHFileInfo;
begin
  with TreeView do begin
  Items.BeginUpdate;
  Integer(Drives) := GetLogicalDrives;
  for ADrive := 0 to 25 do
    if ADrive in Drives then
    begin
      DriveLetter := Chr(ADrive + ord('A'));
      DriveString := DriveLetter + ':\';
      SHGetFileInfo(PChar(DriveString), 0, Sfi, SizeOf(Sfi), SHGFI_DISPLAYNAME);
      DrvName := Copy(Sfi.szDisplayName, 1, (Pos('(', Sfi.szDisplayName) - 1));
      with Items do
      begin
        AddChild(Items[0], ' (' + DriveLetter + ':)  ' + DrvName);
        ShowButtons := True;
        Items[Count - 1].HasChildren := true;
        Items[Count - 1].ImageIndex := GetNormalIcon(DriveString);
        Items[Count - 1].SelectedIndex := GetSelectedIcon(DriveString);
     end;
    end;
  Items.EndUpdate;
  end;
end;

function TForm1.GetNormalIcon(Path: string): integer;
var
  sfi: TShFileInfo;
begin
  SHGetFileInfo(Pchar(Path), 0, sfi, SizeOf(TSHFileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  Result := sfi.iIcon;
end;

function TForm1.GetSelectedIcon(Path: string): Integer;
var
  sfi: TShFileInfo;
begin
  SHGetFileInfo(Pchar(Path), 0, sfi, sizeOf(TSHFileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_OPENICON);
  Result := sfi.iIcon;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  sfi: TShFileInfo;
  hImgLst: Uint;
begin
  OpenPath('Drives');
  FDirectory:='';
  FMask:='*.*';
  SetDirectory('Drives');

  TreeView.Images := TImageList.Create(Self);
  hImgLst := SHGetFileInfo('', 0, sfi, SizeOf(sfi), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  if hImgLst <> 0 then
  begin
    TreeView.Images.Handle := hImgLst;
    Treeview.Images.ShareImages := True;
  end;

  FSortForward := False;
  FSortColumn := 0;
end;

procedure TForm1.OpenPath(dPath: string);
var
  CurNode: TTreeNode;
  count: Integer;
  TempPath,CurPath,FullPath: string;
begin
  FullPath := dPath;
  with TreeView do begin
  Items.BeginUpdate;
  CurNode := Items.GetFirstNode;
  if CurNode.getFirstChild = nil then
    LoadDrives;
  if CurNode.Expanded then
    CurNode.Collapse(True);
  CurNode := Items.GetFirstNode;
  while Pos('\', dPath) > 0 do
  begin
    count := Pos('\', dPath);
    tempPath := Copy(dPath, 1, count);
    dPath := Copy(dPath, count + 1, Length(dPath));
    CurNode := CurNode.getFirstChild;

    while CurNode <> nil do
    begin
      if CurNode.Level = 1 then
        CurPath := AddSlash(Copy(CurNode.Text, 3, 2))
      else if CurNode.Level > 1 then
        CurPath := AddSlash(CurNode.Text);
      if AnsiCompareText(CurPath, tempPath) = 0 then
      begin
        CurNode.Selected := True;
        CurNode.Expand(False);
        Break;
      end;
      CurNode := CurNode.GetNext;
      if CurNode = nil then exit;
    end;
  end;
  Items.EndUpdate;
  if AnsiCompareText(FSelectedPath, FullPath) <> 0 then
  begin
    FSelectedPath := AddSlash(FullPath);
  end;
  end;
end;

procedure TForm1.TreeViewExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
  if Node.GetFirstChild = nil then
  begin
    MakePath(Node);
    Node.HasChildren := false;
    AddSubs(TreeViewPath, Node);
    Node.AlphaSort;
    SetDirectory(GetPathFromNode(Node));
  end;
end;

procedure TForm1.MakePath(Node: TTreeNode);

  procedure MakeSubPath;
  begin
    if Node.Level = 1 then
      TreeViewPath := AddSlash(Copy(Node.Text, 3, 2)) + TreeViewPath
    else if Node.Level > 1 then
      if TreeViewPath = '' then
        TreeViewPath := Node.Text
      else
        TreeViewPath := AddSlash(Node.Text) + TreeViewPath;
  end;

begin
  TreeViewPath := '';
  MakeSubPath;
  while Node.Parent <> nil do
  begin
    Node := Node.Parent;
    MakeSubPath;
  end;
end;

procedure TForm1.AddSubs(Path: string; Node: TTreeNode);
var
  ANode: TTreeNode;
  APath: string;
  hFindFile: THandle;
  Win32FD: TWin32FindData;

  function IsDirectory(dWin32FD: TWin32FindData): Boolean;
  var
    FName: string;
  begin
    FName := StrPas(dWin32FD.cFileName);
    with dWin32FD do
      Result := (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY =
        FILE_ATTRIBUTE_DIRECTORY) and (FName <> '.') and (FName <> '..');
  end;

  function HasSubs(sPath: string): Boolean;
  var
    sAPath: string;
    shFindFile: THandle;
    sWin32FD: TWin32FindData;
  begin
    Result := False;
    sAPath := AddSlash(sPath);
    shFindFile := FindFirstFile(PChar(sAPath + '*.*'), sWin32FD);
    if shFindFile <> INVALID_HANDLE_VALUE then
    try
      repeat
        if IsDirectory(sWin32FD) then
        begin
          Result := True;
          Break;
        end;
      until not FindNextFile(shFindFile, sWin32FD);
    finally
      Windows.FindClose(shFindFile);
    end;
  end;

begin
  with TreeView do begin
  APath := AddSlash(Path);
  hFindFile := FindFirstFile(PChar(APath + '*.*'), Win32FD);
  if hFindFile <> INVALID_HANDLE_VALUE then
  try
    repeat
      if IsDirectory(Win32FD) then
      begin
        ANode := Items.AddChild(Node, Win32FD.cFileName);
        ANode.HasChildren := HasSubs(APath + Win32FD.cFileName);
        ANode.ImageIndex := GetNormalIcon(APath + Win32FD.cFileName);
        ANode.SelectedIndex := GetSelectedIcon(APath + Win32FD.cFileName);
      end;
    until not FindNextFile(hFindFile, Win32FD);
  finally
    Windows.FindClose(hFindFile);
  end;
  end;
end;

procedure TForm1.SetDirectory(NewDir: string);
begin
  if AnsiCompareText(NewDir, FDirectory) = 0 then exit;
  if (UpperCase(NewDir) = 'DRIVES') then
  begin
    FDirectory := NewDir;
    UpdateFileList;
  end
  else
  begin
    if not DirectoryExists(NewDir) then exit;
    NewDir := AddSlash(NewDir);
    SetCurrentDir(NewDir);
    FDirectory := NewDir;
    UpdateFileList;
  end;
end;

procedure TForm1.UpdateFileList;
var
  oldCur: TCursor;
  FileAttr: DWORD;
  CurPath: string;
  MaskPtr, Ptr: PChar;
begin
  with ListView do begin
  Items.BeginUpdate;
  Items.Clear;
  OldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    if UpperCase(FDirectory) = 'DRIVES' then
    begin
      CreateDriveColumns;
      AddDrives
    end
    else
    begin
      CreateFileColumns;
      FileAttr := FILE_ATTRIBUTE_NORMAL;
      if Jenproten1.Checked then FileAttr:= FileAttr or FILE_ATTRIBUTE_READONLY;
      if Skryt1.Checked then FileAttr:= FileAttr or FILE_ATTRIBUTE_HIDDEN;
      if Systmov1.Checked then FileAttr:= FileAttr or FILE_ATTRIBUTE_SYSTEM;
      if Archivan1.Checked then FileAttr:= FileAttr or FILE_ATTRIBUTE_ARCHIVE;
      CurPath := AddSlash(FDirectory);

      MaskPtr := PChar(FMask);
      while MaskPtr <> nil do
      begin
        Ptr := StrScan(MaskPtr, ';');
        if Ptr <> nil then
          Ptr^ := #0;
        AddFiles((CurPath + StrPas(MaskPtr)), FileAttr);
        if Ptr <> nil then
        begin
          Ptr^ := ';';
          inc(Ptr);
        end;
        MaskPtr := Ptr;
      end;
    end
  finally
  end;
  Items.EndUpdate;
  Screen.Cursor := oldCur;
  if (Items.Count > 0) and (SelCount = 0) then
    ItemFocused := Items[0];
  Application.ProcessMessages;
  end;
end;

procedure TForm1.AddDrives;
var
  Drives: set of 0..25;
  NewItem: TListItem;
  i: Integer;
  Drv: Char;

  function GetDriveTypeStr(Root: string): string;
  var
    DrvType: Integer;
  begin
    DrvType := GetDriveType(PChar(Root));
    case DrvType of
      0: Result := 'Neznm';
      1: Result := 'Nexistuje';
      DRIVE_REMOVABLE: Result := 'Vmnn Disk';
      DRIVE_FIXED: Result := 'Pevn Disk';
      DRIVE_REMOTE: Result := 'Sov Disk';
      DRIVE_CDROM: Result := 'CD-ROM';
      DRIVE_RAMDISK: Result := 'RAM Disk';
    end;
  end;

begin
  Integer(Drives) := GetLogicalDrives;
  with ListView do begin
  for i := 0 to 25 do
    if (i in Drives) then
    begin
      Drv := Char(i + Ord('A'));
      NewItem := Items.Add;
      try
        NewItem.Caption := ' (' + Drv + ':)  ';
        NewItem.SubItems.Add(GetDriveTypeStr(Drv + ':\'));
        NewItem.SubItems.Add('drv');
      except
        Items.Delete(NewItem.Index);
      end;
    end;
  end;
end;

function TForm1.AddFiles(FileMask: string; attr: DWord): Boolean;
var
  attributes, CurPath, FName, FileDir: string;
  FSize: Integer;
  hFindFile: THandle;
  Win32FD: TWin32FindData;

  function AttrStr(Attr: integer): string;
  begin
    Result := '';
    if (FILE_ATTRIBUTE_ARCHIVE and Attr) > 0 then Result := Result + 'A';
    if (FILE_ATTRIBUTE_READONLY and Attr) > 0 then Result := Result + 'R';
    if (FILE_ATTRIBUTE_HIDDEN and Attr) > 0 then Result := Result + 'H';
    if (FILE_ATTRIBUTE_SYSTEM and Attr) > 0 then Result := Result + 'S';
  end;

begin
  Result := False;
  CurPath := AddSlash(FDirectory);
  hFindFile := FindFirstFile(PChar(FileMask), Win32FD);
  if hFindFile <> INVALID_HANDLE_VALUE then
  try
    repeat
      with Win32FD do
      begin
        if (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) > 0 then
          FileDir := 'dir'
        else
          FileDir := 'file';
        FName := StrPas(Win32FD.cFilename);

        if (FName = '.') then continue;

        FSize := (nFileSizeHigh * MAXDWORD) + nFileSizeLow;
        Attributes := AttrStr(dwFileAttributes);

        with ListView.Items.Add do
        begin
          if FName = '..' then
            Caption := '.. Parent'
          else
            Caption := FName;

          SubItems.Add(FileDir);
          SubItems.Add(ConvertSize(FSize, FileDir));
          SubItems.Add(Attributes);
          SubItems.Add(CurPath+FName);
        end;

        Result := True;
      end;
    until not FindNextFile(hFindFile, Win32FD);
  finally
    Windows.FindClose(hFindFile);
  end;
  ListView.AlphaSort;
end;

procedure TForm1.CreateDriveColumns;
begin
  with ListView do begin
  Columns.Clear;
  with Columns.Add do
  begin
    Caption := 'Jmno';
    Width := 160;
    Alignment := taLeftJustify;
  end;
  with Columns.Add do
  begin
    Caption := 'Typ';
    Width := 110;
    Alignment := taLeftJustify;
  end;
  with Columns.Add do
  begin
    Caption := 'Attr';
    Width := 30;
    Alignment := taLeftJustify;
  end;
  end;
end;

procedure TForm1.CreateFileColumns;
begin
  with ListView do begin
  Columns.Clear;
  with Columns.Add do
  begin
    Caption := 'Jmno';
    Width := 165;
    Alignment := taLeftJustify;
  end;
  with Columns.Add do
  begin
    Caption := 'Typ';
    Width := 30;
    Alignment := taLeftJustify;
  end;
  with Columns.Add do
  begin
    Caption := 'Velikost(KB)';
    Width := 75;
    Alignment := taRightJustify;
  end;
  with Columns.Add do
  begin
    Caption := 'Attr';
    Width := 40;
    Alignment := taLeftJustify;
  end;
  with Columns.Add do
  begin
    Caption := 'Pln jmno';
    Width := 230;
    Alignment := taLeftJustify;
  end;
  end;
end;

function TForm1.ConvertSize(FSize: integer; FAttr: String): String;
begin
  if (FSize < 1024) and (FSize > 0) then
    FSize := 1024;
  Result := IntToStr(FSize div 1024);
  if (UpperCase(FAttr) = 'DIR') then
    Result := '0';
end;

function TForm1.GetPathFromNode(Node: TTreeNode): string;
begin
  Result := '';
  if Node = nil then exit;
  if Assigned(Node) then
  begin
    MakePath(Node);
    Result := TreeViewPath;
  end;
end;

procedure TForm1.TreeViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  vHitTest: THitTests;
  DrvChar: Char;
begin
  TreeViewPath := '';
  with TreeView do begin
  if Button = mbLeft then
  begin
    vHitTest := GetHitTestInfoAt(X, Y);
    if htOnLabel in vHitTest then
    begin
      if (Selected.Level = 0) and (Items[0].getFirstChild = nil) then
        LoadDrives
      else
        MakePath(Selected);

      if Selected = Items[0] then
        FSelectedPath := 'Drives'
      else
        FSelectedPath := TreeViewPath;

      if Selected.Level = 1 then
        if GetDriveType(PChar(FSelectedPath)) in
          [DRIVE_REMOVABLE, DRIVE_CDROM] then
        begin
          DrvChar := FSelectedPath[1];
          if DiskSize(ord(DrvChar)- $40) = -1 then exit;
        end;
      if (FSelectedPath <> '') then SetDirectory(FSelectedPath);
    end;
  end;
  end;
  if Button = mbRight then PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;


procedure TForm1.ListViewDblClick(Sender: TObject);
var
  sFile, sDir: string;
  cDrv: Char;
  oldCur: TCursor;
begin
  with ListView do begin
  if Selected = nil then exit;
  OldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  if (Selected.Caption = '.. Parent') then
  begin
    LevelUp;
    Screen.Cursor := oldCur;
    exit;
  end;
  if (Selected.SubItems[1] = 'drv') then
  begin
    sDir := Copy(Selected.Caption,3,2);
    sDir := AddSlash(sDir);
    if GetDriveType(PChar(sDir)) = DRIVE_REMOVABLE then
      begin
        cDrv := (Copy(Selected.Caption,3,1))[1];
        if DiskSize(ord(cDrv) - $40) = -1 then
        begin
          Screen.Cursor := OldCur;
          exit;
        end;
      end;
    SetDirectory(sDir);
    OpenPath(sDir);
  end
  else if (Selected.SubItems[0] = 'dir') then
  begin
    sDir := Selected.SubItems[3];
    sDir := AddSlash(sDir);
    if (Selected.SubItems[1] = 'drv') and
      (GetDriveType(PChar(sDir)) = DRIVE_REMOVABLE) then
      begin
        cDrv := (Copy(Selected.Caption,3,1))[1];
        if DiskSize(ord(cDrv) - $40) = -1 then
        begin
          Screen.Cursor := OldCur;
          exit;
        end;
      end;
    SetDirectory(sDir);
    OpenPath(sDir);
  end
  else if Selected.SubItems[0] = 'file' then
  begin
    sFile := ExtractFileName(Selected.SubItems[3]);
    sDir := ExtractFilePath(Selected.SubItems[3]);
    ExecuteFile('Open', sFile, '', sDir, SW_SHOW);
  end;
  Screen.Cursor := OldCur;
  end;
end;

procedure TForm1.LevelUp;
var
  NewDir: string;
begin
  if UpperCase(FDirectory) = 'DRIVES' then
    exit;
  FDirectory := AddSlash(FDirectory);
  if (FDirectory[Length(FDirectory) - 1] = ':') then
  begin
    OpenPath(TreeView.Items[0].Text);
    SetDirectory('Drives');
  end
  else begin
    FDirectory := Copy(FDirectory, 1, Length(FDirectory) - 1);
    NewDir := ExtractFilePath(FDirectory);
    SetDirectory(NewDir);
    OpenPath(NewDir);
  end;
end;

function TForm1.ExecuteFile(const Operation, FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zOperation: array[0..79] of Char;
  zFileName: array[0..79] of Char;
  zParams: array[0..79] of Char;
  zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.Handle,
    StrPCopy(zOperation, Operation),
    StrPCopy(zFileName, FileName),
    StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
  if Result <= 32 then
    MessageDlg('Chyba nemu provst poadovanou akci se souborem ' +
      FileName, mtError, [mbOK], 0);
end;

procedure TForm1.TreeViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  DrvChar: Char;
begin
  with TreeView do begin
  if (key = VK_RETURN) then
  begin
    if selected = nil then exit;
    if (Selected.Level = 0) and (Items[0].getFirstChild = nil) then
      LoadDrives
    else
      MakePath(Selected);

    if (Selected.Level = 0) then
      FSelectedPath := 'Drives'
    else
      FSelectedPath := TreeViewPath;

    if Selected.Level = 1 then
      if GetDriveType(PChar(FSelectedPath)) in
        [DRIVE_REMOVABLE, DRIVE_CDROM] then
      begin
        DrvChar := FSelectedPath[1];
        if DiskSize(ord(DrvChar) - $40) = -1 then
          exit;
      end;
      SetDirectory(FSelectedPath);
  end;
  end;
end;

procedure TForm1.ListViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with ListView do begin
  case Key of
    VK_RETURN:
      if Selected <> nil then ListViewDblClick(Self);
    VK_BACK: LevelUp;
   end;
  end;
end;

procedure TForm1.EditKeyPress(Sender: TObject; var Key: Char);
var
  sFile, sDir, attr: string;
  Count: integer;

begin
  if ord(Key) = VK_RETURN then
  begin
    Count:=Pos(' ',Edit.Text);
    if Count=0 then
    begin
      attr:='';
      Count:= Length(Edit.Text);
    end
    else attr:= Copy(Edit.Text,Count+1, Length(Edit.Text)-Count+1);
    sDir:= Copy(Edit.Text,1,Count);
    sFile:= ExtractFileName(sDir);
    sDir:= ExtractFilePath(sDir);
    ExecuteFile('Open', sFile, attr, sDir, SW_SHOW);
  end;
end;

procedure TForm1.Soubor1Click(Sender: TObject);
begin
  ExecuteFile('Open', 'notepad.exe', '', FDirectory, SW_SHOW);
  UpdateFileList;
end;

procedure TForm1.Sloka1Click(Sender: TObject);
var
  NewFolder: string;
  NewDir: string;
  Handle: THandle;
begin
  NewFolder := 'Nov adres';
  NewDir := '';
  if not InputQuery('Vytven adrese', 'Zadejte jmno adrese', NewFolder) then
    exit;
  Handle := GetFocus;

  if Handle=ListView.Handle then
    NewDir := AddSlash(FDirectory) + NewFolder;
  if Handle=TreeView.Handle then
    NewDir := AddSlash(GetPathFromNode(TreeView.Selected)) + NewFolder;

  if FileDirExist(NewDir) then
  begin
    ShowMessage('Adres ji existuje');
    exit;
  end;

  CreateDir(NewDir);
  UpdateFileList;

  Reload;
  OpenPath(NewDir);
end;

function TForm1.FileDirExist(FDName: string): Boolean;
var
  SRec: TSearchRec;
  FName: string;
begin
  FillChar(SRec, SizeOf(TSearchRec), 0);
  Result := FindFirst(FDName, faAnyFile or faDirectory, SRec) = 0;
  if Result then
  begin
    FName := ExtractFileName(DelSlash(FDName));
    if (FName[Length(FName)] = #0) then
      FName := Copy(FName, 1, Length(FName) - 1);
//    ShowMessage('Chyba - "' + FName + '" u existuje !');
  end;
  SysUtils.FindClose(SRec);
end;

function TForm1.DelSlash(Path: string): string;
begin
  Result := Path;
  if Path <> '' then
    if Path[Length(Path)] = '\' then
      Delete(Result, Length(Path), 1);
end;

procedure TForm1.ReLoad;
begin
  with TreeView do begin
  Items.BeginUpdate;
  Items.Clear;
  LoadRoot;
  LoadDrives;
  Items.EndUpdate;
  end;
end;

procedure TForm1.LoadRoot;
begin
  with TreeView do begin
  Items.BeginUpdate;
  Items.Clear;
  Items.AddFirst(nil, 'Root');
  Items.EndUpdate;
  end;
end;

procedure TForm1.DeleteItems(all: integer);
var
  i,j: integer;
  DelFName: string;
  FSelectedFiles: TStrings;

begin
  FSelectedFiles:= TStringList.Create;
  with ListView do begin
  if not SetCurrentDir(FDirectory) then exit;
  try
    FSelectedFiles.Clear;
    for i := 0 to Items.Count - 1 do
      if Items[i].Selected then
        FSelectedFiles.Add(Items[i].SubItems[3]);
    for i := 0 to FSelectedFiles.Count - 1 do
    begin
      DelFName := '';
      DelFName := FSelectedFiles.Strings[i];
      if all <> mrAll then
        all:= CreateMessageDialog('Chcete smazat soubor/adres ' +DelFName,
          mtWarning,[mbYes,mbNo,mbAll,mbCancel]).ShowModal;
      if all = mrCancel then
        exit;
      if all <> mrNo then
        if not DeleteFile(DelFName) then
          if DirectoryExists(DelFName) then
          begin
            SetDirectory(DelFname);
              for j := 1 to Items.Count - 1 do
                Items[j].Selected:= true;
            DeleteItems(all);
            SetCurrentDir('..');
            if all = mrCancel then exit;
            if not RemoveDir(DelFName) then
              ShowMessage('Nemu smazat ' + DelFName);
          end
          else
            ShowMessage('Nemu smazat' + DelFName);
    end;
  finally
    FSelectedFiles.Free;
  end;
  end;
end;

procedure TForm1.Sma1Click(Sender: TObject);
var
  Handle: THandle;
  OldCur: TCursor;
  all: integer;
  CurDir: string;

begin
  oldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  all:= mrCancel;
  Handle := GetFocus;
  CurDir:= FDirectory;

  ListView.Items.BeginUpdate;
  if Handle=ListView.Handle then
  begin
    TreeView.Enabled:= false;
    DeleteItems(all);
    FDirectory:=CurDir;
    TreeView.Enabled:= true;
  end
  else if Handle=TreeView.Handle then
  begin
    TreeView.Items.BeginUpdate;
    DeleteNode(all);
    SetDirectory('..');
    if not RemoveDir(GetPathFromNode(TreeView.Selected)) then
      ShowMessage('Nemu smazat ' + GetPathFromNode(TreeView.Selected))
    else
      FDirectory:=ExtractFilePath(copy(CurDir,1,Length(CurDir)-1));
    TreeView.Items.EndUpdate;
  end;
  Edit.Text:= FDirectory;
  UpdateFileList;
  Reload;
  OpenPath(FDirectory);
  Screen.Cursor:= oldCur;
  ListView.Items.EndUpdate;
end;

procedure TForm1.DeleteNode(all: integer);
var
  i: integer;
  DelFName: string;
  FSelectedFiles: TStrings;

begin
  FSelectedFiles:= TStringList.Create;
  with ListView do begin
  if not SetCurrentDir(FDirectory) then exit;
  try
    FSelectedFiles.Clear;
    for i := 1 to Items.Count - 1 do
      FSelectedFiles.Add(Items[i].SubItems[3]);
    for i := 0 to FSelectedFiles.Count - 1 do
    begin
      DelFName := '';
      DelFName := FSelectedFiles.Strings[i];
      if all <> mrAll then
        all:= CreateMessageDialog('Chcete smazat soubor/adres ' +DelFName,
          mtWarning,[mbYes,mbNo,mbAll,mbCancel]).ShowModal;
      if all = mrCancel then
        exit;
      if all <> mrNo then
        if not DeleteFile(DelFName) then
          if DirectoryExists(DelFName) then
          begin
            SetDirectory(DelFname);
            DeleteNode(all);
            SetCurrentDir('..');
            if all = mrCancel then exit;
            if not RemoveDir(DelFName) then
              ShowMessage('Nemu smazat ' + DelFName);
          end
          else
            ShowMessage('Nemu smazat' + DelFName);
    end;
  finally
    FSelectedFiles.Free;
  end;
  end;
end;

procedure TForm1.Najdi1Click(Sender: TObject);
begin
  ExecuteFile('Find', FDirectory, '', '', SW_SHOWNORMAL);
end;

procedure TForm1.Select1Click(Sender: TObject);
var
  Mask, FName : string;
  i, index: integer;
  hFindFile: THandle;
  Win32FD: Win32_Find_Data;
  List: TStringList;

begin
  Mask:= '*.*';
  if not InputQuery('Vybrn masky', 'Zadejte masku', Mask) then
    exit;
  if Mask = '*.*' then
  begin
    VyberVechny1Click(Self);
    Exit;
  end;

  List:= TStringList.Create;
  hFindFile := FindFirstFile(PChar(Mask), Win32FD);
  if hFindFile <> INVALID_HANDLE_VALUE then
  try
    repeat
      with Win32FD do
      begin
          FName := Win32FD.cFilename;
          if (FName = '.') or (FName = '..') then continue;
          List.Add(Fname);
      end;
    until not FindNextFile(hFindFile, Win32FD);
  finally
    windows.FindClose(hFindFile);
  end;

  List.Sort;
  with ListView do begin
  for i := 0 to (Items.Count - 1) do
    if List.Find(Items[i].Caption, Index) then
      Items[i].Selected:=true;
  end;

  List.Free;
end;

procedure TForm1.Kopruj1Click(Sender: TObject);
var
  Path, OldPath: string;
  oldCur: TCursor;
  all: integer;

begin
  if GetFocus<>ListView.Handle then exit;
  Path:= FDirectory;
  if not InputQuery('Koprovn souboru', 'Zadejte clovou cestu', Path) then
    exit;
  oldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  all:= mrCancel;
  OldPath:= FDirectory;
  TreeView.Enabled:= false;
  ListView.Items.BeginUpdate;
  Copyfiles(Path, all);
  TreeView.Enabled:= true;
  FDirectory:= OldPath;
  UpdateFileList;
  Reload;
  OpenPath(FDirectory);
  Screen.Cursor := oldCur;
  ListView.Items.EndUpdate;
end;

procedure TForm1.Copyfiles(Path: string; all: integer);
var
  i,j: integer;
  FSelectedFiles: TStrings;
  FPath, FName: string;
begin
  FSelectedFiles:= TStringList.Create;

  with ListView do begin
  FSelectedFiles.Clear;
  for i := 0 to Items.Count - 1 do
    if Items[i].Selected then
      FSelectedFiles.Add(Items[i].SubItems[3]);
  FPath:=Path;
  for i := 0 to FSelectedFiles.Count - 1 do
  begin
    FName := '';
    FName := FSelectedFiles.Strings[i];
    if not DirectoryExists(Path) then
    begin
      if FileDirExist(FPath) then
      begin
        if all <> mrAll then
          all:= CreateMessageDialog('Chcete pepsat soubor/adres ' +
            FPath, mtWarning,[mbYes,mbNo,mbAll,mbCancel]).ShowModal;
        if all = mrCancel then
          exit;
        if all <> mrNo then
          if not CopyFile(Pchar(FName), PChar(FPath), false) then
            if DirectoryExists(Fname) then
            begin
              if not CreateDir(FPath) then
              begin
                ShowMessage('Nemu zkoprovat ' + FName);
                Continue;
              end;
              SetDirectory(FName);
              for j := 1 to Items.Count - 1 do
                Items[j].Selected:= true;
              Copyfiles(FPath, all);
              SetCurrentDir('..');
            end
            else ShowMessage('Nemu zkoprovat ' + FName)
      end
      else if not CopyFile(Pchar(FName), PChar(FPath), true) then
        if DirectoryExists(Fname) then
        begin
          if not CreateDir(FPath) then
          begin
            ShowMessage('Nemu zkoprovat ' + FName);
            Continue;
          end;
          SetDirectory(FName);
          for j := 1 to Items.Count - 1 do
            Items[j].Selected:= true;
          Copyfiles(FPath, all);
          SetCurrentDir('..');
        end
        else ShowMessage('Nemu zkoprovat ' + FName)
    end
    else
    begin
      FPath:=AddSlash(Path) + ExtractFileName(FName);
      if FileDirExist(FPath) then
      begin
        if all <> mrAll then
          all:= CreateMessageDialog('Chcete pepsat soubor/adres ' +
            FPath, mtWarning,[mbYes,mbNo,mbAll,mbCancel]).ShowModal;
        if all = mrCancel then
          exit;
        if all <> mrNo then
          if not CopyFile(Pchar(FName), PChar(FPath), false) then
            if DirectoryExists(Fname) then
            begin
              if not CreateDir(FPath) then
              begin
                ShowMessage('Nemu zkoprovat ' + FName);
                Continue;
              end;
              SetDirectory(FName);
              for j := 1 to Items.Count - 1 do
                Items[j].Selected:= true;
              Copyfiles(FPath,all);
              SetCurrentDir('..');
            end
            else ShowMessage('Nemu zkoprovat ' + FName)
      end
      else if not CopyFile(Pchar(FName), PChar(FPath), true) then
        if DirectoryExists(Fname) then
        begin
          if not CreateDir(FPath) then
          begin
            ShowMessage('Nemu zkoprovat ' + FName);
            Continue;
          end;
          SetDirectory(FName);
          for j := 1 to Items.Count - 1 do
            Items[j].Selected:= true;
          Copyfiles(FPath,all);
          SetCurrentDir('..');
        end
        else ShowMessage('Nemu zkoprovat ' + FName)
    end;
  end;
  FSelectedFiles.Free;
  end;
end;

procedure TForm1.Pesu1Click(Sender: TObject);
var
  Path, OldPath: string;
  oldCur: TCursor;
  all, i, Index: integer;
  List: TStringList;

begin
  if GetFocus<>ListView.Handle then exit;
  Path:= FDirectory;
  if not InputQuery('Pesouvn/Pejmenovvn souboru', 'Zadejte clovou cestu', Path) then
    exit;
  oldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  all:= mrCancel;

  OldPath:=FDirectory;
  with ListView do begin
  Items.BeginUpdate;
  List:= TStringList.Create;
  for i := 0 to Items.Count - 1 do
    if Items[i].Selected then
      List.Add(Items[i].SubItems[3]);
  TreeView.Enabled:= false;
  Copyfiles(Path, all);
  SetDirectory(OldPath);
  for i := 0 to Items.Count - 1 do
    Items[i].Selected:= false;
  List.Sort;
  for i := 0 to Items.Count - 1 do
    if List.Find(Items[i].SubItems[3], Index) then Items[i].Selected:= true;
  end;
  Deleteitems(all);
  TreeView.Enabled:= true;
  FDirectory:=OldPath;

  UpdateFileList;
  Reload;
  OpenPath(FDirectory);
  ListView.Items.EndUpdate;
  Screen.Cursor := oldCur;
end;

procedure TForm1.Opus1Click(Sender: TObject);
begin
  if MessageDlg('Opravdu chcete skonit?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
    Form1.Close;
end;

procedure TForm1.Skryt1Click(Sender: TObject);
begin
  Skryt1.Checked:= not Skryt1.Checked;
  UpdateFileList;
end;

procedure TForm1.Systmov1Click(Sender: TObject);
begin
  Systmov1.Checked:= not Systmov1.Checked;
  UpdateFileList;
end;

procedure TForm1.Jenproten1Click(Sender: TObject);
begin
  Jenproten1.Checked:= not Jenproten1.Checked;
  UpdateFileList;
end;

procedure TForm1.Archivan1Click(Sender: TObject);
begin
  Archivan1.Checked:= not Archivan1.Checked;
  UpdateFileList;
end;

procedure TForm1.Maska1Click(Sender: TObject);
begin
  InputQuery('Zadvn nov masky', 'Zadejte novou masku', FMask);
  UpdateFileList;
end;

procedure TForm1.ListViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TForm1.Spotejvelikost1Click(Sender: TObject);
var
  Size: LongWord;
  OldPath: string;

  procedure CalculateSize;
  var
    i,j: integer;
    FSelectedFiles: TStrings;
    FSize: TStrings;
    FAttr: TStrings;

  begin
    FSelectedFiles:= TStringList.Create;
    FSize:= TStringList.Create;
    FAttr:= TStringList.Create;
    with ListView do begin
    if not SetCurrentDir(FDirectory) then
      begin
        SetDirectory(AddSlash(Copy(Selected.Caption,3,2)));
        for j := 0 to Items.Count - 1 do
          Items[j].Selected:= true;
        CalculateSize;
      end;
    try
      FSelectedFiles.Clear;
      FSize.Clear;
      FAttr.Clear;
      for i := 0 to Items.Count - 1 do
        if Items[i].Selected then
        begin
          FSelectedFiles.Add(Items[i].SubItems[3]);
          FSize.Add(Items[i].SubItems[1]);
          FAttr.Add(Items[i].SubItems[0]);
        end;
      for i := 0 to FSelectedFiles.Count - 1 do
      begin
        if UpperCase(FAttr[i]) = 'FILE' then
          Size:= Size + StrToInt(FSize[i])
        else if UpperCase(FAttr[i]) = 'DIR' then
        begin
          SetDirectory(FSelectedFiles[i]);
          for j := 1 to Items.Count - 1 do
            Items[j].Selected:= true;
          CalculateSize;
        end;
     end;
    finally
      FSelectedFiles.Free;
      FSize.Free;
      FAttr.Free;
    end;
    end;
  end;

begin
  if GetFocus <> ListView.Handle then exit;
  Size:= 0;
  OldPath:= FDirectory;
  ListView.Items.BeginUpdate;
  CalculateSize;
  SetDirectory(OldPath);
  ListView.Items.EndUpdate;
  ShowMessage('Vybran soubory a adrese mly ' +
    IntToStr(Size) + ' KB');
end;

procedure TForm1.Volnmsto1Click(Sender: TObject);
var
  FreeDiskSize: Extended;
  Root: string;

  procedure GetFreeDiskSize;
  var
    SpC, BpS, NfC, TnC: DWORD;
  begin
    GetDiskFreeSpace(PChar(Root), SpC, BpS, NfC, TnC);
    FreeDiskSize := Nfc * SpC;
    FreeDiskSize := (FreeDiskSize * BpS) / 1024;
    FreeDiskSize:= Round(FreeDiskSize);
  end;

begin
  if (GetFocus <> ListView.Handle) or (ListView.Selected = nil) then exit;
  if UpperCase(FDirectory) = 'DRIVES' then
    Root:= AddSlash(Copy(ListView.Selected.Caption,3,2))
  else
    Root:= Copy(FDirectory,1,3);
  GetFreeDiskSize;
  ShowMessage('Voln msto na ' + Root + ' je ' + FloatToStr(FreeDiskSize) +
  #13 + '               (Max. 2GB)');
end;

procedure TForm1.Kapacitadisku1Click(Sender: TObject);
var
  DiskSize: Extended;
  Root: string;

  procedure GetDiskSize;
  var
    SpC, BpS, NfC, TnC: DWORD;
  begin
    GetDiskFreeSpace(PChar(Root), SpC, BpS, NfC, TnC);
    DiskSize := TnC * SpC;
    DiskSize := (DiskSize * BpS) / 1024;
    DiskSize := Round(DiskSize);
  end;


begin
  if (GetFocus <> ListView.Handle) or (ListView.Selected = nil) then exit;
  if UpperCase(FDirectory) = 'DRIVES' then
    Root:= AddSlash(Copy(ListView.Selected.Caption,3,2))
  else
    Root:= Copy(FDirectory,1,3);
  GetDiskSize;
  ShowMessage('Kapacita disku ' + Root + ' je ' + FloatToStr(DiskSize) +
    #13 + '                (Max. 2GB)');
end;

procedure TForm1.ListViewChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  Size: LongInt;
  i, SCount: integer;

begin
  if (GetFocus = ListView.Handle) and (UpperCase(FDirectory) <> 'DRIVES') then
  begin
    Size:= 0;
    SCount:= 0;
    with ListView do begin
    for i:=0 to Items.Count - 1 do
      if Items[i].Selected then
      begin
        Size:= Size + StrToInt(Items[i].SubItems[1]);
        Inc(SCount);
      end;

    StatusBar.Panels[0].Text:= IntToStr(Items.Count - 1) + ' poloek - ' +
      IntToStr(SCount) + ' vybrno';
    StatusBar.Panels[1].Text:= 'Velikost vybranch poloek ' + IntToStr(Size) + ' KB';
    end;
  end;
  if ListView.Selected = nil then exit;
  if UpperCase(FDirectory) = 'DRIVES' then
    Edit.Text:= AddSlash(Copy(ListView.Selected.Caption,3,2))
  else if ListView.Selected.Caption = '.. Parent' then
    Edit.Text:= FDirectory
  else Edit.Text:= FDirectory + ListView.Selected.Caption;
end;

procedure TForm1.Vybervechny1Click(Sender: TObject);
var
  i: integer;
begin
  with ListView do begin
  Items.BeginUpdate;
  for i:=1 to Items.Count - 1 do
    Selected:= Items[i];
  Items.EndUpdate;
  end;
end;

procedure TForm1.TreeViewEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
  OldNode, OldName, NewName: string;
begin
  with TreeView do begin
  OldName:= GetPathFromNode(Node);
  OldNode:= Node.Text;
  NewName:= AddSlash(ExtractFilePath(Copy(OldName,1, Length(OldName) - 1))) + S;
  if not RenameFile(OldName, NewName) then
  begin
    ShowMessage('Nemu pejmenovat ' + OldName);
    S:=OldNode;
  end
  else
    FDirectory:= NewName;
  end;
end;

procedure TForm1.ListViewEdited(Sender: TObject; Item: TListItem;
  var S: String);
var
  OldName, NewName: string;
begin
  S:= Item.Caption;
{  with ListView do begin
  if UpperCase(FDirectory) <> 'DRIVES' then OldName:= Item.SubItems[3]
  else OldName:= Item.Caption;
  NewName:= AddSlash(ExtractFilePath(Copy(OldName,1, Length(OldName) - 1))) + S;
  if not RenameFile(OldName, NewName) then
  begin
    ShowMessage('Nemu pejmenovat ' + OldName);
    if UpperCase(FDirectory) = 'DRIVES' then
      S:=OldName
    else
      S:= ExtractFileName(OldName);
  end
  else
    FDirectory:= ExtractFilePath(NewName);
  end;}
end;

procedure TForm1.Prohldni1Click(Sender: TObject);
begin
  if (GetFocus <> ListView.Handle) and (ListView.Selected = nil) then
    Exit;
  if UpperCase(ListView.Selected.SubItems[0]) <> 'FILE' then
    Exit;
  Form2.Caption:= 'Prohlen souboru ' + ListView.Selected.Caption;
  Form2.Memo.Lines.Clear;
  Form2.Show;
  Form2.Memo.Lines.LoadFromFile(ListView.Selected.SubItems[3]);
end;

end.
